# MobileEventLog
A cross plattform project for android and ios to log events offline everywhere and sync them to sensor. Developed with flutter.

## Minimum Concept
- Config page: Select the collection and get corresponding devices, get all event types. Store all this to a local configuraion.json file. 

- Log page: Allow selection of a device and adding a new event with all details. Add button adds the event to the staged events. Fields are not cleared but kept as they are. 
  
- Staged Event: Show all entered and not yet uploaded events. Allow modification of all fields here.
- Synced Event: Show all uploaded events. Optionally filter by device.  


## Questions:
- How to store not uploaded events locally?  Dumping jsons to a file?, ObjectBox,  SharedPreferences, 



## Local Base Data Concept
- The configuration.dart age widget is used to get the online available information for available
  devices and event creation. 
- This includes: All collections, All devices part of a selected collection, Event operation types
- This "base data" is required to provide the dropdown menu options on the addevent.dart page.
- This "base data" needs to be stored persistently, so that it is available also offline!

## Local Data Event Storage 
- Events added on the addevent.dart page have to be stored locally persistently. At least until the 
  are exported to sensor.awi.de
 
## Configuration Page
- Dropdown "Collection" to select a collection
- Textfield to show current locally selected and offline available collection  
- Button "get Collection devices from Sensor"
- Button "store Collection devices locally"




## GNSS
- Checkbox on add event page which activates GNSS locationing. A field shall signal "no fix" or presision in meter. 
The fields lat, long, elevation are updated automatically if checkbox is checked. 



# Input validation 

a-z , A-Z , _ , 0-9 , ,(Comma) , ( , ) , + , - , . , : 
 
-90 => Latitude <= +90
-180 => Latitude <= +180
 Elevation: any numer
 
